/*
 * $Id: Corpdefs.h,v 1.4 2005-10-04 09:05:29 tonydodd Exp $
 *
 * $Log: not supported by cvs2svn $
 * Revision 1.4  1996/05/12 23:36:15  scotty
 * v927 fixes from Tony.
 *
 * Revision 1.3  1996/03/01 23:51:55  scotty
 * Changed MAXSIG to MAX_SIG since MAXSIG is defined on Solaris.
 *
 * Revision 1.2  1996/02/26 21:10:22  scotty
 * Changed the definition of LOG_FACILITY so that it is overridden by
 * the Makefile. Removed the definition of BNC_PORT since it is set
 * in the Makefile or in corpprm.c.
 *
 * Revision 1.1  1996/02/15 01:28:44  scotty
 * Initial revision
 *
 */
#include "xarastruc0old.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef CORPDEFS_H
# define CORPDEFS_H

# include <stdio.h>
# include "Exttypes.h"

#  define LOG_EMERG   0
#  define LOG_ALERT   0
#  define LOG_CRIT    0
#  define LOG_ERR     0
#  define LOG_WARNING 0
#  define LOG_NOTICE  0
#  define LOG_INFO    0
#  define LOG_DEBUG   0

#  define LOG_KERN    0
#  define LOG_USER    0
#  define LOG_MAIL    0
#  define LOG_DAEMON  0
#  define LOG_AUTH    0
#  define LOG_SYSLOG  0
#  define LOG_LPR     0
#  define LOG_NEWS    0
#  define LOG_UUCP    0
#  define LOG_CRON    0
#  define LOG_COMPAT  0
#  define LOG_LOCAL0  0
#  define LOG_LOCAL1  0
#  define LOG_LOCAL2  0
#  define LOG_LOCAL3  0
#  define LOG_LOCAL4  0
#  define LOG_LOCAL5  0
#  define LOG_LOCAL6  0
#  define LOG_LOCAL7  0

#  define LOG_PID     0
#  define LOG_CONS    0
#  define LOG_ODELAY  0
#  define LOG_NDELAY  0
#  define LOG_NOWAIT  0
#  define LOG_PERROR  0


# if defined(LOG_MAIL) /* modern syslog */
#  if !defined(LOG_FACILITY)
#   define LOG_FACILITY  LOG_LOCAL7
#  endif /* ! LOG_FACILITY */
# endif /* LOG_MAIL */


# define VER 950

# if !defined(TRUE)
#  define TRUE 1
#  define FALSE 0
# endif /* ! TRUE */


# if !defined(_WIN32)
#  define SEPCHAR  '/'
#  define SEPCHARS  "/"
#  define NL       "\x0a"
# else /* ! __unix__ */
#  define SEPCHAR  '\\'
#  define SEPCHARS  "\\"
#  define NL       "\x0d\x0a"
# endif /* __unix__ */

# if !defined(_WIN32)
#  define __cdecl
#  define __pascal
# endif /* __unix__ */

# if !defined(_WIN32) || defined(WIN32)
#  define __far
# endif /* __unix__ || WIN32 */


typedef int BOOL;

typedef sara_long STRSAVE;


# define MN_EXIT            1
# define MN_INDEX           2
# define MN_HDR             3
# define MN_MERGE           4
# define MN_SORT            5
# define MN_COMPRESS        6
# define MN_STATS           7
# define MN_SQUERY          8
# define MN_MAIN            9
# define MN_UTIL           10
# define MN_QUERY          11
# define MN_BROWSE         12
# define MN_VIEW           13
# define MN_POS            14
# define MN_SGML           15
# define MN_PHRASE         16
# define MN_BRIEF          17
# define MN_GOTO           18
# define MN_SUBQUERY       19
# define MN_DISCARD        20
# define MN_SELECTION      21
# define MN_SAVE           22
# define MN_LOAD           23
# define MN_LEFT           24
# define MN_RIGHT          25
# define MN_CONF           26
# define MN_WORDLIST       27
# define MN_OPTIONS        28
# define MN_CASE           29
# define MN_SSC            30
# define MN_CLEAN          31
# define MN_BUILD          32
# define MN_SERVER         33
# define MN_HDR2           34
# define MN_DICT           35
# define MN_PINDEX         36
# define MN_FINDEX         37
# define MN_BM             38
# define MN_BIBL           39
# define MN_HDR3           40
#define MN_SIG 41
#define MN_TEST 42
#define MN_SC 43
#define MN_DEREG 44

# define MD_COMMENT         0
# define MD_MSO             1
# define MD_MSE             2
# define MD_ENT             3
# define MD_ERR             4

# define MAX_CODE           20
# define MAX_ROOT           12
# define MAXINC           100
# define MAXEXC           100
#define MAXOMIT 100
# define MAXNAME            16
#define MAXQUERY 100
# define MAXENTS          500
#define MAXWTAGS 10
#define MAXXA 100
# define MAXCENTS         1400
# define MAXVAL            20
# define MAXWORD           200
#define MAXCONTENT			80000
#define MAXLC 100
#define MAXPOSLENGTH 10
#define MAXCNAME 16
#define MAXENTLENGTH 10
#define MAXELTS 200
#define MAXGATTS 300
#define MAXGENTS 200
#define MAXGDESC 5000
#define MAXLAB 10


#  define MAXOPENIND       10
#  define MAXSORT           1
#  define MAXIDICT        5000
#  define MAXILOC0        30000 // use 10000 for bncsam2
#  define MAXIWORDS         (MAXIDICT*MAXWORD)
#  define MAXTEXTS        15000
# define MAXOPS           100

#define MAXRE 100000
# define MAXIBYTES      10000
# define MAX_SIG          100
# define MAXMENUTITLE      30+MAXWORD
# define MAXMENUITEM       40
# define MAXSPECS          40
# define MAXSENTENCE     100000
# define MAXATTVAL        500
# define MAXSORTQUERY    1000
# define MAXATTS           10
# define MAXSC            100

# define ACCMAX            10
#define MAXPCQ 10

# define MAXFROBPOS      1500
# define MAXFROBS         600
# define MAXMUL            70
# define MAXPHRASE        200
# define MAXENC            10
            
#define MAXCORPNAME 100            
            
# define nhash0             10
# define nhashsig0           3
# define hashshift0          2
# define hashlast0           3

# define C6OFFSET        1000

# define HDRPOS          2000
#define HASHPOS 1000000

# define INDEXVER           2


# define ID_ALLPOS          0
# define ID_WORD            it_content
# define ID_TAGO            it_start
# define ID_TAGE            it_end
# define ID_N               4
# define ID_R  5
# define ID_W        6
# define ID_WPOS      7
# define ID_C          8
# define ID_CPOS           9


# define CO_CON             0
# define CO_REF             1
# define CO_LIT             2
# define CO_LITA            3
# define CO_TAG             4


# define CH_STAGO           2
# define CH_ETAGO           1
# define CH_TAGC            3
# define CH_ERO             5
# define CH_CRO             4
# define CH_REFC            6
# define CH_LIT             7
# define CH_LITA            0
# define CH_VI              8
#define CH_TAGCE  9
# define CH_EOF            10
# define CH_CHAR           11


# define SG_STARTTAG        1
# define SG_ENDTAG          2
# define SG_CREF            3
# define SG_PREF            4
# define SG_CHAR            5
# define SG_ATT             6
#define SG_ETAG             7


# define SORT_NATURAL       1
# define SORT_LEFT          2
# define SORT_RIGHT         3
# define SORT_IP            4


# define DWIDTH            79
# define LWIDTH             DWIDTH*5


# define TY_ATOM            1
# define TY_OR              2
# define TY_NEG             3
# define TY_ALL             4
# define TY_SEQ             5
# define TY_FILE            6
# define TY_AND             7
# define TY_PROD            8
# define TY_LIMIT           9
# define TY_SUBCORPUS      10
# define TY_ID             11
# define TY_IDC            12
# define TY_BPROD          13
# define TY_CASE           14

# define LG_EMPTY           1
# define LG_ELEMENT         2
# define LG_SENT            3

# define LT_SGML            1
# define LT_NULL            2
# define LT_INT             3
# define LT_XSGML           4

# define AL_LEFT            1
# define AL_RIGHT           2
# define AL_CENTRE          3


# define CSTART_CHAR        '&'
# define CEND_CHAR          ';'


# if !defined(SOURCEDIR)
#  if !defined(_WIN32)
#   define SOURCEDIR         "./"
#  else /* ! __unix__ */
#   define SOURCEDIR         "c:\\sgml\\server\\"
#  endif /* __unix__ */
# endif /* ! SOURCEDIR */

#  define INDEXNAME         "files.ndx"
#  define PINDEXNAME        "files.rdx"
#  define DICTNAME          "corpus.dct"

# define INDEXEXT           ".idx"
# define INCNAME            "files.inc"
# define EXCNAME            "files.exc"
# define ENTNAME            "cdfents.par"
# define ELTNAME            "cdif.txt"
# define CHARNAME           "cdchar.par"
# define HDRNAME            "corpents.c"
# define HDR2NAME           "corpelts.c"

# define C5NAME             "%c5tags;"
# define C6NAME             "%c6tags;"

# define DOCTYPE            "bncDoc"
# define DOCTAG             "<bncDoc"

#define BIBNAME "bibliog.sgm"
# define PBIBNAME           "pbib"

#if !defined(_WIN32)
#  define _MAX_PATH         _POSIX_PATH_MAX
#endif /* __unix__ */

# if !defined(SEEK_SET)
#  define SEEK_SET          0
#  define SEEK_CUR          1
#  define SEEK_END          2
# endif /* ! SEEK_SET */

#define DEFSTRENGTH 1

extern char  accpath[];
extern char  chdpath[];
extern char  etcpath[];
extern char  srtpath[];
extern char  tmppath[];
extern char  txtpath[];
extern char  bibname[];


enum attval {
   AT_CDATA,   AT_CAT,     AT_NUM,     AT_NAME,    AT_REFID,
   AT_ID,      AT_NULL,    AT_MULTID,  AT_MULTIDREF,
   AT_NMTOKENS, AT_CATT
};


# define AT_PLURAL          0x4000


struct menuitem {
   int       code;
   char     *item;
};


struct menu {
   char     *title;
   int       nitems;
   struct menuitem mi[20];
};


struct sgml {
   int       type;
   char      name[MAXNAME + 1];
   char      val[MAXATTVAL + 1];
   sara_long pos;
   int       id;
};


//#  pragma pack(2)
enum _st {ST_SPACE,ST_DEL,ST_CHAR,ST_PUNCT};


struct cdef {
   char     cname[MAXCNAME];
   int       val;
   enum _st st;
};

struct _lc {
	int u;
	int l;
};


struct ientry {
   int       type;
   char     *string;
   sara_long pos;
   WORDNO    word;
   int       extra;
   int hash;
};


//#  pragma pack()


struct lookup {
   xairo_uchar      word[MAXWORD + 1];
   int       nsig;
   int       ihash;
   int       last;
   int       lf;
   int       sel;

   struct {
      int       extra;
      int       type;
      int       first;
      int       ff;
	  int		acc;
	  xairo_uchar spell[MAXWORD+1];
   }         sig[MAX_SIG];
};


struct stream {
   int            type;
   xairo_uchar           word[MAXWORD];
   xairo_uchar           xword[MAXWORD];
   int            extra;
   int            wtype;
   int            first;
   int            ff;
   int            last;
   int            lf;
   sara_long      cursor;
   sara_ulong     lcode;
   sara_long      pos;
   WORDNO         wpos;
   int            nw;
   int            lw, lw0;
   int pre, nxt;
   int            ihash;
   FILE          *handle;
   int            ops;
   struct stream *op[MAXOPS];
   sara_long      oldcursor;
   sara_long      oldpos;
   sara_ulong     oldlcode;
   WORDNO         oldwpos;
   sara_long      count;
   int            wc;
   BOOL           bOptional;
   struct stream *limit1;
   struct stream *limit2;
   int            limtype;
   int            limint;
   BOOL           bFilter;
   int            kvar;
   int            nkvals;
   WORDNO         kval[10];
   xairo_uchar skval[MAXWORD];
   xairo_uchar skvar[MAXWORD];
   int            frobno, frobpos;
   int				acc;
};


struct _ft {
   char      word[20];
   int       frob;
   int       offset;
   BOOL      b1,
             b2;
};


struct regexp {
   char           op;
   struct regexp *op1;
   struct regexp *op2;
   char           rep;
   xairo_uchar           ch;
   int            set;
};

struct regexpnew {
	void* imp;
};


struct atab {
   xairo_uchar      word[MAXWORD];
   int       type;
   int       extra;
};    

struct _pcq {
	char elt[MAXNAME];
	char att[MAXNAME];
	char attval[MAXATTVAL];
	int val;
	char cql[MAXQUERY];     
	sara_long ns;
	int nt;
};

#define MAXLTNAME 256
#define MAXNAK 10

struct _lemmatab {
	char name[MAXLTNAME];
	int idx;
	char info[MAXLTNAME];
};


extern char             idxpath[];

extern int              port;
extern int              nback;
extern int              timeout;
extern BOOL             bDebug;
extern int              nbuff;
extern BOOL             bSysLog;
extern int              xgran;

extern FILE            *fIndex;
extern FILE            *fLog;
extern FILE            *fDict;
extern FILE            *fDicta;
extern FILE            **fLocs;
extern FILE            **fThread;
extern FILE            *fPack;
extern FILE			   *fStreamBase;
extern FILE            *fWL;

extern FILE            *fBib;
extern FILE            *fBibIndex;

extern int              npos;
extern int              nctab;
extern int              nlabs;
extern int				ncase;
extern int nwt, nlt, nxa;

struct _wtg {
	char name[MAXNAME];
	char pos[MAXNAME];
};

struct _pos {
	char name[MAXPOSLENGTH];
	BOOL bPun;
};	
extern struct _wtg  wtags[MAXWTAGS];
extern struct _wtg  ltags[MAXWTAGS];
extern struct _wtg  xadic[MAXXA];
extern struct _pos            postab[MAXENTS];
extern struct cdef      ctab[MAXCENTS];
extern struct dicent    dict[MAXIDICT];
extern struct locent    locs[MAXILOC0];
extern struct atab      acctab[ACCMAX];
extern struct _pcq pcqtab[MAXPCQ];	               
extern struct _lc lctab[MAXLC];

extern int              nacc;
extern int npc;

extern struct ihdr      header;

extern char             words[MAXIWORDS];

extern struct stream    qs;

extern int              filter[MAXSORTQUERY];

extern BOOL             bFilter;
extern sara_int nhash;
extern sara_int nhashsig;
extern sara_int hashshift;
extern sara_int hashlast;
extern int hashcharmask;
extern int hashlastmask;
extern int hashrange;
extern sara_int maxiloc;
extern sara_int npages;
extern sara_int maxiloct;
extern sara_int npagest;

extern int              nfil;
extern int              natts;
extern int              ntexts;          
extern int				nukatts, nukents;
extern int              nukpos;



extern struct _labels {
	char element[MAXNAME];
	char attribute[MAXNAME];
} labels[MAXLAB];


extern struct _atttab {
   char      name[MAXNAME + 1];
   char      element[MAXNAME + 1];
   int       val;
   enum attval attv;
   char     *attdesc;
} atttab[];

extern struct _ukatttab {
   char      name[MAXNAME + 1];
   char      element[MAXNAME + 1];
   BOOL bEnd;
} uktab[];

extern char uketab[MAXGENTS][MAXNAME+1];

extern enum _st lextab[256];

extern int              hdv;
extern int              nelts;
extern int              kps;


extern struct _eltab {
   char      name[MAXNAME + 1];
   int       eltype;
   enum _st  st;
   BOOL		 bInternal;
} eltab[];

//extern struct _eltab uketab[];
struct _ent {
	char name[MAXENTLENGTH];
	char disp[MAXENTLENGTH];
};	  

extern char ukpos[MAXENTS][MAXNAME];

extern BOOL             bServer;
extern BOOL             bStreamErr;

extern int              nspec;
extern struct _ent            specs[MAXSPECS];

extern sara_long        ndix;

extern struct xara_lemma_header     dicthead;

extern BOOL             bInt;
extern BOOL             bTrace;

extern char             incf[MAXINC][MAX_CODE + 1];
extern char             excf[MAXEXC][MAX_CODE + 1];

extern int              ninc;
extern int              nexc;

extern int              nfrobpos;
extern char             frobuff[MAXPHRASE];
extern int              nfrobs;
extern char            *frobs[MAXFROBS];
extern int              nmul;
extern char            *mul[MAXMUL];
extern char            *demul[MAXMUL];
extern struct _ft       fptab[MAXFROBPOS];
extern int              nenclitic;
extern char            *enclit[MAXENC];
extern BOOL             bCase;
extern BOOL             bHdr;
extern BOOL             bLemma;
extern BOOL bInit;                    
extern char corpname[];
extern BOOL c6, oldnames, oldid, oldcr, stags;
extern char website[];
extern int nprmerrs;
extern char txt0[MAXNAME];
extern char defscope[MAXNAME];
extern BOOL bNoPos, bNameCase;
extern int isc;
extern int nlemma;
extern int nlemmatab;
extern struct _lemmatab lemmatab[];

#endif /* CORPDEFS_H */

#ifdef __cplusplus
}
#endif
