#include "Corpinc.h"

#define MAXSCA 100
#define ALL_NAME "all"
#define MAXSCNAMES 100
#define MAXSCNAME 128

struct _sctab {
	char name[MAXSCNAME];
	int nt;
	unsigned texts[MAXTEXTS];
//	int nnames;
//	char names[MAXSCNAMES][MAXSCNAME];
	char desc[1000];
	BOOL bReg;
} sctab[MAXSCA];

static unsigned oldt=10000; static BOOL oldb;


int FindSubCorpus(const char*);
void RefreshDict();
BOOL Stats(char*,double*,double*,long*,long*);
BOOL GetDictName(char*,char*);
int LocToDoc(sara_long,sara_ulong);
long SCCountWords(char*,int);

const xairo_uchar* GetTaxName(int);
int GetNTax();
int GetTaxClasses(const xairo_uchar*,int*);

int nsc=0;
int isc=0;
int ip=0;

BOOL NewSubCorpus(const char* name,const char* desc)
{
	int k;
	k=FindSubCorpus(name);
	if (k==0) return FALSE;
	else if (k==-1) {
		if (nsc+1 >= MAXSCA) return FALSE;
		strcpy(sctab[nsc].name,name);
		strcpy(sctab[nsc].desc,desc);
		sctab[nsc].texts[0]=sctab[nsc].texts[1]=0; // header
		k=nsc++;
	} else k--;
	sctab[k].nt=1;
	sctab[k].bReg=FALSE;
//	sctab[k].nnames=0;
	return TRUE;
}

BOOL SetSubCorpus(const char* name)
{
	int k;
	k=FindSubCorpus(name);
	if (k==-1) return FALSE;
	isc=k; ip=0; oldt=10000;
	RefreshDict();
	return TRUE;
}

BOOL SetSubCorpusPart(const char* name,int p)
{
	int k;
	k=FindSubCorpus(name);
	if (k==-1) return FALSE;
	isc=k; ip=p; oldt=10000;
//	RefreshDict();
	return TRUE;
}

BOOL SetSubCorpusND(const char* name)
{
	int k;
	k=FindSubCorpus(name);
	if (k==-1) return FALSE;
	isc=k;
	return TRUE;
}

BOOL AddSubCorpus(const char* name,int n, int* p)
{
	int i, k, t;
	k=FindSubCorpus(name);
	if (k<=0) return FALSE;
	k--;
	t=sctab[k].nt;
	for (i=0;i<n;i++) {
		if (p[i]==0) {
			break;
		}
		sctab[k].texts[t++]=p[i];
	}
	sctab[k].nt=t;
	return TRUE;
}

BOOL SetSubCorpusNames(const char* name,char* names)
{
	int k; char* part; int i=0;
	return FALSE;
	k=FindSubCorpus(name);
	if (k<=0) return FALSE;
	k--;
	part=strtok(names," ");
	while (part != NULL) {
		if (i>=MAXSCNAMES) return FALSE;
//		strcpy(sctab[k].names[i],part);
		part=strtok(NULL," ");
		i++;
	}
//	sctab[k].nnames=i;
	return TRUE;
}

int FindSubCorpus(const char* name)
{
	int i;
	if (!strcmp(name,ALL_NAME)) return 0;
	for (i=0;i<nsc; i++) {
		if (!strcmp(name,sctab[i].name)) return i+1;
	}
	return -1;
}

BOOL TestSubCorpus2(unsigned t, int is,int p)
{
	int k;
	if (p==0) return TRUE;
	if (is==0) {
		if (p==1) return t==0;
		else return t>0;
	}
	k=is-1;
  	return (sctab[k].texts[t]==(unsigned) p-1);

}

BOOL TestSubCorpus(unsigned t)
{
	int k;

	if (ip==0) return TRUE;
	if (isc==0) {
		if (ip==1) return t==0;
		else return t>0;
	}
	k=isc-1;
	return (sctab[k].texts[t]==(unsigned) ip-1);
}

void SCDel(char* name)
{
	int k, i, j;
	k=FindSubCorpus(name);
	if (k<=0) return;
	k--;
	for (i=k+1;i<nsc;i++) {
		strcpy(sctab[i-1].name,sctab[i].name);
		strcpy(sctab[i-1].desc,sctab[i].desc);
//		sctab[i-1].nnames=sctab[i].nnames;
//		for (j=0;j<sctab[i].nnames;j++) {
//			strcpy(sctab[i-1].names[j],sctab[i].names[j]);
//		}
		sctab[i-i].nt=sctab[i].nt;
		for (j=1;j<sctab[i].nt;j++) 
			sctab[i-1].texts[j]=sctab[i].texts[j];
		sctab[i-1].bReg=sctab[i].bReg;
	}
	nsc--;
}


BOOL SCSave(char* path)
{
	FILE* f; int n; int i;
//	strcpy(path,tmppath);
//	strcat(path,sctab[isc-1].name);
//	strcat(path,".scn");
//	f=fopen(path,"w");
//	n=sctab[isc-1].nnames;
//	for (i=0;i<n;i++) {
//		fprintf(f,"%s\n",sctab[isc-1].names[i]);
//	}
//	fclose(f);
	strcpy(path,tmppath);
	strcat(path,sctab[isc-1].name);
	strcat(path,".sc");
	f=fopen(path,"w");
	if (f==NULL) return FALSE;
	n=sctab[isc-1].nt;
	for (i=0;i<n;i++) {
		fprintf(f,"%d\n",sctab[isc-1].texts[i]);
	}
	fclose(f);
	return TRUE;
}

BOOL SCReadNew(int i) 
{
	char n[MAXNAME];
	const xairo_uchar* name=GetTaxName(i); int t, k;
	wcstombs(n,name,MAXNAME);
	if (!NewSubCorpus(n,"")) return FALSE;
	k=FindSubCorpus(n);
	if (k==-1) return FALSE;
	strcpy(sctab[k-1].name,n);
//	strcpy(sctab[k-1].desc,desc);
	t=GetTaxClasses(name,sctab[k-1].texts);
	sctab[k-1].nt=t;
	sctab[k-1].bReg=FALSE;
	return TRUE;
}

BOOL SCRead(char* name,char* desc)
{
	FILE* f; int k; int t;
	char path[_MAX_PATH]; char line[100];
	strcpy(path,etcpath);
	strcat(path,name);
	strcat(path,".sc");
	f=fopen(path,"r");
	if (f==NULL) {
		return FALSE;
	}
	if (!NewSubCorpus(name,"")) return FALSE;
	k=FindSubCorpus(name);
	if (k==-1) return FALSE;
	strcpy(sctab[k-1].name,name);
	strcpy(sctab[k-1].desc,desc);
	t=0;
	while (fgets(line,sizeof line,f)) {
		if (line[0]==0 || isspace(line[0])) continue;
		sctab[k-1].texts[t++]=atoi(line);
	}
	sctab[k-1].nt=t;
//	syslog(LOG_DEBUG,"Read %d entries",t);
	sctab[k-1].bReg=FALSE;
	fclose(f);
//	strcpy(path,etcpath);
//	strcat(path,name);
//	strcat(path,".scn");
//	f=fopen(path,"r");
//	t=0;
//	while (fgets(line,sizeof line,f)) {
//		int kk=strlen(line)-1;
//		while (kk>0 && isspace(line[kk])) kk--;
//		line[kk+1]=0;
//		strcpy(sctab[k-1].names[t++],line);
//	}
//	sctab[k-1].nnames=t;
//	fclose(f);
	return TRUE;
}

void SCReadAll()
{
	int n, i;
	n=GetNTax();
	for (i=0;i<n;i++)
		SCReadNew(i);
}
/*	FILE* f;
	char path[_MAX_PATH]; char line[1000]; char name[MAXSCNAME];
	strcpy(path,etcpath);
	strcat(path,"screg");
	f=fopen(path,"r");
	if (f==NULL) return;
	nsc=0;
	while (fgets(line,sizeof line,f)) {
		int k;
		sscanf(line,"%s %n",name,&k);
		SCRead(name,line+k);
	}
	fclose(f);
}
*/

void SCWriteAll()
{
	FILE* f; int i;
	char path[_MAX_PATH];
	strcpy(path,etcpath);
	strcat(path,"screg");
	f=fopen(path,"w");
	if (f==NULL) return;
	for (i=0;i<nsc;i++) {
		fprintf(f,"%s %s\n",sctab[i].name,sctab[i].desc);
	}
	fclose(f);
}

char scbuffer[1000];

int SCCount()
{
	return nsc+1;
}

const char* SCName(int i)
{
	return sctab[i].name;
}

char* SCList(int n)
{
	double fm=0; double fs=0; long nw, nu;
	BOOL bR=Stats(sctab[n-1].name,&fm,&fs,&nw,&nu);	
	sprintf(scbuffer,"%s %d %d %lf %lf %ld %ld %s",sctab[n-1].name,sctab[n-1].nt,bR,fm,fs,nw,nu,sctab[n-1].desc);
	return scbuffer;
}

void SCEnumNames(const char* name,char* buffer) 
{
	int k=FindSubCorpus(name); // int i;
	return;
	buffer[0]=0;
	if (k<1) return;
//	sprintf(buffer,"%d",sctab[k-1].nnames);
//	for (i=0;i<sctab[k-1].nnames;i++) {
//		strcat(buffer," ");
//		strcat(buffer,"{");
//		strcat(buffer,sctab[k-1].names[i]);
//		strcat(buffer,"}");
//	}
}

char* SCEnum(const char* name,int i0,int ik)
{
	int i;
	int k=FindSubCorpus(name);
	scbuffer[0]=0; 
	if (k < 1) return scbuffer;
	for (i=i0;i<i0+ik;i++) {
		char x[10];
		sprintf(x,"%d ",sctab[k-1].texts[i]);
		strcat(scbuffer,x);
	}
	scbuffer[strlen(scbuffer)-1]=0;
	return scbuffer;
}


void GetFTable(char* path)
{
	GetDictName(path,"sdic");
}


BOOL GetDictName(char* path,char* root)
{
//	if (!strcmp(root,"streambase") && LemmaGetScheme()==0) return FALSE;
	strcpy(path,etcpath);
	strcat(path,root);
	strcat(path,".");
	if (isc==0 || ip==0 || !sctab[isc-1].bReg)
		strcat(path,"all.");
	else {
		char x[10];
		strcat(path,sctab[isc-1].name);
		strcat(path,".");
		sprintf(x,"%s",ip);
		strcat(path,x);
		strcat(path,".");

	}
	strcat(path,LemmaName(LemmaGetScheme()));
	return TRUE;
}

BOOL Stats(char* name,double* fm,double* fs,long* nw,long* nu) // eek - this is still in use!
{
	char path[_MAX_PATH]; FILE *f; struct dhead dh; *nw=*nu=0;
	strcpy(path,etcpath);
	strcat(path,"dic.");
	strcat(path,name);
	strcat(path,".");
	strcat(path,"null");
	f=fopen(path,"r");
	if (f==NULL) return FALSE;
	if (fread(&dh,sizeof(dh),1,f) != 1) {
		fclose(f);
		return FALSE;
	}
//	if (dh.version > 0) {fclose(f); return FALSE;}
	*fm=0;
	*fs=0;
	*nw=dh.nw;
	*nu=dh.nu;

	fclose(f);
	return TRUE;
}



void RefreshDict()
{
   char  dpath[_MAX_PATH];
	if (fDict) fclose(fDict);
   GetDictName(dpath,"dic");

   if ((fDict = fopen(dpath, "r")) == 0) 
		return;
   fread(&dicthead, sizeof(dicthead), 1, fDict);
   fix_dhead(&dicthead, 1);
   ndix=dicthead.ndix;
	if (fDicta) fclose(fDicta);
   GetDictName(dpath,"dica");

   fDicta = fopen(dpath, "r"); 
//	if (fStreamBase) fclose(fStreamBase);
   GetDictName(dpath,"streambase");
	
//	if ((fStreamBase = fopen(dpath, "r")) == 0) 
//			return;
	g_uc0=LemmInfo()[2];
///	GetDictName(dpath,"qad");
//	QADLoad(dpath);
}                                            

BOOL SCRegistered()
{
//	syslog(LOG_DEBUG,"In screg isc=%d ip=%d",isc,ip);
	return ip==0 || sctab[isc-1].bReg;
}

long NUsages()
{
//	double m, sd; long nw, nu;
	if (isc==0) 
		return dicthead.nu;
	return SCCountWords(sctab[isc-1].name,ip);
//	Stats(sctab[isc-1].name,&m,&sd,&nw,&nu);
//	return nu;
}

int SBCount(struct locent *l, int k)
{
	int t=0; int d; int i; int p=0;
	if (isc==0 || ip==0) return k;
	d=LocToDoc(l->pos,l->lcode);
	for (i=0;i<k;i++, l++) {
		if (sctab[isc-1].texts[d]==(unsigned) ip-1) t++;
	}
	return t;
}
	
long SCCountWords(char* name,int p)
{
	int is=FindSubCorpus(name); int i;
	long k=0;
	if (is==0) {
		for (i=0;i<ntexts;i++) 
			if (p==0 || (p==1 && i==0) || (p==2 && i>0)) k+=CountWords(i);
		return k;
	}
	for (i=0;i<sctab[is-1].nt;i++)
		if (p==0 || sctab[is-1].texts[i]==(unsigned) p-1) k+=CountWords(i);
	return k;
}
