#include "SServer.h"
#include "Accelerators.h"
#include "Parameters.h"
#include "DataReader.h"

XAIRO_NAMESPACE_BEGIN

CAccelerators::CAccelerators(CXairoServer* s):m_server(s)
{
}

CAccelerators::~CAccelerators(void)
{
}

bool CAccelerators::Load()
{
	FILE* f=_wfopen(m_server->GetParam()->exppath(PARAM_INDEXPATH,L("xdbaccel")),L("rb"));
	if (f==NULL) {
		m_server->BootLog(L("The file xdbaccel is missing\n"));
		return false;
	}
	CDataReader* d=new CDataReader(0,f);
	xara_ahdr ahd;
	d->ReadAhdr(1,&ahd);
	m_na=ahd.na;
	m_acctab=new int*[ahd.na];
	m_nt=ahd.nt;
	for (int i=0;i<ahd.na;i++) {
		m_acctab[i]=new int [ahd.nt+1];
		d->ReadAccel(ahd.nt,m_acctab[i]);
	}
	fclose(f);
	return true;
}

int CAccelerators::First(int a,int d)
{
	return m_acctab[a][d];
}

int CAccelerators::Last(int a,int d)
{
	return m_acctab[a][d+1];
}

// change indexer so this isn't needed
void CAccelerators::SetLast(int a,int x)
{
	m_acctab[a][m_nt]=x;
}

XAIRO_NAMESPACE_END
