#pragma once

XAIRO_NAMESPACE_BEGIN

class CDataReader
{
public:
	CDataReader(int,FILE*);
	~CDataReader();
	int ReadThread(int,int*,int);
	int ReadWLHash(int,int*);
	int ReadWLHeader(int,xara_wl_header*);
	int ReadLemmaHeader(int,xara_lemma_header*);
	int ReadWLHeaderAddkey(int,xara_wl_header_addkey*);
	int ReadWLHeaderTax(int,xara_wl_header_tax*);
	int ReadWLFile(int,xara_wl_file*);
	int ReadWChars(int,xairo_uchar*);
	int ReadLemma(int,int,xara_lemma*);
	int ReadForm(int,xara_form*);
	int ReadType(int,xara_type*);
	int ReadStreamBase(int,int,xara_streambase*);
	int ReadAhdr(int,xara_ahdr*);
	int ReadLocHdr(int,xara_loc_hdr*);
	int ReadLocPage(int,xara_loc_page*);
	int ReadAccel(int,int*);
	int ReadLoc(int,xara_loc*,int);

	void Seek(int);
private:
	FILE* m_file;
	int m_n;
	static bool bRev;
	void Swap8(__int64&);
};

XAIRO_NAMESPACE_END
