#pragma once

#include "SServer.h"

XAIRO_NAMESPACE_BEGIN

class CWord;

class CDictionary
{
public:
	CDictionary(CXairoServer*);
	~CDictionary(void);
	bool GetLimits(const xairo_uchar* w,int&,int&);
//	int GetIndex(int);
//	const xairo_uchar* GetEntry(int i,int& freq,int& forms);
//	bool GetEntry(const xairo_uchar*,int&,int&);
//	CWord* GetEntry(const xairo_uchar*);
	xara_lemma* LookupEntry(int);
	xara_lemma* LookupEntry(const xairo_uchar*);
	xara_lemma* LookupEntry2(int,UnicodeString*);
	int WordIndex(const xairo_uchar*);
	int GetHeadwordIndex(xara_word*);
	bool Load(int);
//	bool GetForm(const xairo_uchar*,int,int&,int&,int&);
	int GetMaxFreq();
	int GetNextFreq(int);
	int GetNUsages() {return m_dicthead.nu;}
	void SetFacets(int n,int* f) {m_nf=n; m_f=f;}
	int Count() {return m_dicthead.ndix;}
private:
	CXairoServer* m_server;
	bool GetLimits(const xairo_uchar* w,int,int,int&,int&);
	int m_ndix;
	char* m_ll;
	struct xara_lemma_header m_dicthead;
	int* m_llr;
	int m_ns;
	int m_nf;
	int* m_f;

};

XAIRO_NAMESPACE_END
