#pragma once

#include <xercesc/dom/DOM.hpp>
using namespace XERCES_CPP_NAMESPACE;

#ifndef _WIN32
#define XAIRO_API
typedef unsigned short xairo_uchar;
#else
#define XAIRO_API __declspec(dllimport)
typedef wchar_t xairo_uchar;
#define L(x) L ## x
#endif


enum xmlrpc_type {XMLRPC_STRING,XMLRPC_I4,XMLRPC_BOOL,XMLRPC_DOUBLE,XMLRPC_VECTOR,XMLRPC_VECTORS};

struct xmlrpc_arg {
	xmlrpc_type t;
	const xairo_uchar* s;
	int i;
	double d;
	int nvec;
	int* vec;
	const xairo_uchar** vecs;
};

#define XMLRPC_NULL L("null")


DOMElement* RPCParam(DOMElement* e,int n);	
DOMElement* RPCValue(DOMElement* e);
const xairo_uchar* RPCString(DOMElement* e);
const xairo_uchar* RPCStringParam(DOMElement* e,int);
int RPCInt(DOMElement* e);
double RPCDouble(DOMElement* e);
int RPCIntParam(DOMElement*,int);
double RPCDoubleParam(DOMElement*,int);
bool RPCBool(DOMElement* e);
bool RPCBoolParam(DOMElement*,int);
int RPCVector(DOMElement*,int*&);
int RPCVectorParam(DOMElement*,int,int*&);
int RPCVectors(DOMElement*,const xairo_uchar**&);
int RPCVectorsParam(DOMElement*,int,const xairo_uchar**&);
const xairo_uchar* RPCName(DOMElement* e);
DOMElement* RPCStruct(DOMElement* e);
const xairo_uchar* RPCBoolRet(bool);
const xairo_uchar* RPCIntRet(int);
const xairo_uchar* RPCStringRet(const xairo_uchar*);
const xairo_uchar* RPCParams(int n,const xmlrpc_arg* x);
const xairo_uchar* RPCRet(int n,xmlrpc_arg* x);
const xairo_uchar* RPCCall(const xairo_uchar*,int n,const xmlrpc_arg* x);
const xairo_uchar* RPCUnescape(const xairo_uchar*);
const xairo_uchar* RPCEscape(const xairo_uchar*);
const xairo_uchar* RPCFault(int,const xairo_uchar*);
const xairo_uchar* RPCFormat(const xairo_uchar*,...);

