#include "SServer.h"
#include "Thread.h"
#include "Parameters.h"

XAIRO_NAMESPACE_BEGIN

CThread::CThread(CXairoServer* s):m_server(s),m_npage(-1)
{
}

CThread::~CThread()
{
	delete [] m_thpa;
	delete [] m_loctab;
	delete [] m_fThread;
}



bool CThread::Load()
{
	FILE *fL=_wfopen(m_server->GetParam()->exppath(PARAM_INDEXPATH,L("xdbthread")),L("rb"));
	if (fL==NULL) 
	{
		m_server->BootLog(L("Thread file 0 missing\n"));
		return false;
	}
	CDataReader* d=new CDataReader(0,fL);
	d->ReadLocHdr(1,&m_loc_hdr);
	m_fThread=new FILE* [m_loc_hdr.nf];
	m_fThread[0]=fL;
	for (int i=1;i<m_loc_hdr.nf;i++) {
		xairo_uchar p[_MAX_PATH];
		swprintf(p,L("xdbthread%d"),i);
		m_fThread[i]=_wfopen(m_server->GetParam()->exppath(PARAM_INDEXPATH,p),L("rb"));
		if (m_fThread[i]==NULL) {
			m_server->BootLog(L("Thread file %d missing\n"),i);
			return false;
		}
	}
	m_loctab=new xara_loc_page[m_loc_hdr.np];
	d->ReadLocPage(m_loc_hdr.np,m_loctab);
	m_maxiloc=m_loc_hdr.ps;
	m_npages=m_loc_hdr.np;
	m_thpa=new int[m_maxiloc];
	return true;
}

 
int CThread::GetThread(int n)
{
	int np=n / m_maxiloc;
	int ni=n % m_maxiloc;
	if (np != m_npage) {
		ReadPage(np,m_thpa);
		m_npage=np;
	}
	return m_thpa[ni];
}

void CThread::ReadPage(int n,int* b)
{
	int off=m_loctab[n].off;
	int len=m_loctab[n].len;
	int nf=m_loctab[n].fi;
	fseek(m_fThread[nf],off,SEEK_SET);
	CDataReader d(0,m_fThread[nf]);
	d.ReadThread(m_loc_hdr.ps,b,len);
}

XAIRO_NAMESPACE_END
