#pragma once

XAIRO_NAMESPACE_BEGIN


enum _tkop {XT_ORB,XT_CRB,XT_OSB,XT_CSB,XT_PARENT,XT_CTXT,
XT_AT,XT_COMMA,XT_AXIS,XT_COLON,XT_VAR,
XT_LITERAL,XT_NCNAME,XT_NUMBER,XT_OP,XT_ALL,
XT_AXISNAME,XT_FUNCTION,XT_END,XT_UNKNOWN};

enum et {ET_OP,ET_LITERAL,ET_NUMBER,ET_NCTEST,ET_NCATEST,ET_ALLTEST,ET_FUNCTION,ET_BRACKETS};



enum etop {ETOP_DESC,ETOP_CHILD,ETOP_UNION,ETOP_PLUS,ETOP_EQUALS,
		ETOP_NEQ,ETOP_LE,ETOP_LT,ETOP_GE,ETOP_GT,ETOP_MUL,
		ETOP_OR,ETOP_AND,ETOP_MOD,ETOP_DIV,ETOP_MINUS,ETOP_MAX};

enum _fn {FN_LAST,FN_POSITION,FN_COUNT,FN_CQL,FN_MAX};

struct _xptoken {
	_tkop ty;
	const xairo_uchar* val;
	_xptoken() {}
	_xptoken(_tkop t,const xairo_uchar* v):ty(t),val(v) {}
};

struct _xpe {
	et etype;
	etop op;
	_fn fn;
	_xpe* op1;
	_xpe* op2;
	const xairo_uchar* s;
	const xairo_uchar* pre;
	int ntests;
	_xpe** tests;
	int nargs;
	_xpe** args;
	void *usr;
};



class CXPathTokeniser
{
public:
	CXPathTokeniser(CXairoServer*);
	~CXPathTokeniser(void);
	_xptoken NextToken(const xairo_uchar*,int&);
	void Adjust(int,_xptoken*);
	_xpe* Parse(int,int);
	_xpe* Parse(const xairo_uchar*);

private:
	CXairoServer* m_server;
	_xptoken* m_toks;
	int m_ntoks;
	bool PreProc(_xpe*);
};

XAIRO_NAMESPACE_END
