#include "SServer.h"
#include "Grammar.h"
#include "StreamFactory.h"

#include "XairoAttributeValue.h"
#include "XairoCorpusTextFilter.h"

XAIRO_NAMESPACE_BEGIN


CXairoAttributeValue::~CXairoAttributeValue()
{
}

int CXairoAttributeValue::getFilteredFrequency(const CXairoICorpusTextFilter* f)
{
	int * sc;
	int nsc=((CXairoCorpusTextFilter*) f) -> getTexts(sc);
	int k=0;
	CAtomStream* s=m_server->GetSF()->Make1Stream(m_sb);
	if (s!=NULL)
		k+=s->Count(nsc,sc);
	delete [] sc;
	return k;
}

#define FAV L("av(%d)")

const xairo_uchar* CXairoAttributeValue::getId()
{
	return CXairoServer::MakeId(FAV,m_sb);
}

CXairoAttributeValue::CXairoAttributeValue(const xairo_uchar* id,CXairoServer* s):m_server(s)
{
	CXairoServer::ScanId(FAV,id,&m_sb);
}


XAIRO_NAMESPACE_END
