#pragma once
#include "SServer.h"
#include "XairoAttributeValueList.h"
#include "XairoAttributeValue.h"
#include "Grammar.h"
#include "SB.h"
#include "WordList.h"

#include "KDB.h"

XAIRO_NAMESPACE_BEGIN


CXairoAttributeValueList::CXairoAttributeValueList(CDBKey* k,const CXairoIGrammar::Codebook* cb,CXairoServer* s):m_key(k),m_server(s),m_cb(cb)
{
}

CXairoAttributeValueList::~CXairoAttributeValueList()
{
}

CXairoIAttributeValue* CXairoAttributeValueList::getAttributeValue(int n)
{
	int p;
	if (!m_server->GetDB()->recorded(m_key,n,&p)) return 0;
	xara_streambase* sb=m_server->GetSB()->GetSB(p);
	const xairo_uchar* gloss=L("");
	const xairo_uchar* name=m_server->GetWL()->GetWordW(sb->w.val);
	if (m_cb) gloss=m_cb->lookup(name);
	return new CXairoAttributeValue(name,sb->count,gloss,p,m_server);
}

int CXairoAttributeValueList::getCount()
{
	return m_server->GetDB()->countrecords(m_key);
}


#define AVL L("avl(%d)")

const xairo_uchar* CXairoAttributeValueList::getId()
{
	return CXairoServer::MakeId(AVL,m_key->getId());
}

CXairoAttributeValueList::CXairoAttributeValueList(const xairo_uchar* id,const xairo_uchar* cbid,CXairoServer* s):m_server(s)
{
	if (wcscmp(cbid,L("null"))==0)
		m_cb=NULL;
	else 
		m_cb=new CXairoGrammar::Codebook(cbid,m_server);
	int k=CXairoServer::ScanId(AVL,id);
	m_key=m_server->GetDB()->getKey(k,sizeof(int));
}

XAIRO_NAMESPACE_END
