#include "SServer.h"
#include "XairoCorpusTextFilter.h"
#include "XairoSolveError.h"
#include "Stream.h"

XAIRO_NAMESPACE_BEGIN

CXairoCorpusTextFilter::CXairoCorpusTextFilter(CDBKey* k,CXairoServer* s):m_key(k),m_server(s)
{
	m_bOwns=true;
}

CXairoCorpusTextFilter::~CXairoCorpusTextFilter()
{
	m_server->GetDB()->deletekey(m_key);
}

#define FCTF L("ctf(%d)")

CXairoCorpusTextFilter::CXairoCorpusTextFilter(const xairo_uchar* id,CXairoServer* s):m_server(s)
{
	int k;
	CXairoServer::ScanId(FCTF,id,&k);
	m_key=m_server->GetDB()->getKey(k,sizeof(int));
	m_bOwns=false;
}

int CXairoCorpusTextFilter::getTexts(int*& t)
{
	int nt=m_server->GetDB()->countrecords(m_key);
	t=new int[nt];
	for (int i=0;i<nt;i++) {
		m_server->GetDB()->recorded(m_key,i,&t[i]);
	}

	return nt;
}


const xairo_uchar* CXairoCorpusTextFilter::getId()
{
	m_bOwns=false;
	return CXairoServer::MakeId(FCTF,m_key->getId());
}

int CXairoCorpusTextFilter::OnOffMap(int*& x)
{
	int* p;
	int np=getTexts(p);
	CAtomStream* ds=m_server->GetDocumentStream();
	int sd=0; bool b=false; int id=0;
	int t=0; int* px=new int [np]; 
	while (ds->Advance(sd,true)) {
		bool bNew=(id >= 0 && id < np && p[id]);
		if (bNew != b) {
			px[t++]=ds->m_seq;
			b=bNew;
		}
		id++;
		sd=ds->m_seq+1;
	}
	x=new int [t];
	for (int i=0;i<t;i++)
		x[i]=px[i];
	delete [] px;
	return t;
}

XAIRO_NAMESPACE_END
