#pragma once

#include "../XairoHeader.h"

#include "XairoHit.h"
#include "XairoCollocationTable.h"

XAIRO_NAMESPACE_BEGIN



struct _clim {
	bool bByN;
	int maxn;
	double mins, maxs;
	int low;
	_clim(int n,int lo=0):bByN(true),maxn(n),low(lo) {}
	_clim(double mis,double mas=1.0E50,int lo=0):bByN(false),mins(mis),maxs(mas),low(lo) {}
};

struct _colt {
//	int w;
	int x;
	int freq;
	double score;
	int p;
};

#include "XairoCollocationTable.h"
//enum cmeth {CM_Z,CM_MI,CM_MAX};


class CXairoSolution : public CXairoISolution
{
public:
	CXairoSolution(CDBKey*,const CXairoGrammar::Partition*,CXairoServer*);
	CXairoSolution(const xairo_uchar*,CXairoServer*);
	~CXairoSolution();
	XAIRO_API_EXPORT int getCount();
	XAIRO_API_EXPORT int getCorpusTextCount();
	XAIRO_API_EXPORT CXairoHit* getHit(int);
	XAIRO_API_EXPORT CXairoISolution* thinInit(int);
	XAIRO_API_EXPORT CXairoISolution* thinRand(int,int);
	XAIRO_API_EXPORT CXairoISolution* thinOnePerText();
	XAIRO_API_EXPORT CXairoISolution* thinSelection(int,int*);
	XAIRO_API_EXPORT CXairoISolution* thinSubcorpus(int,int*);
	XAIRO_API_EXPORT CXairoISolution* thinCollocation(const xairo_uchar*,CXairoICollocationTable::_cwin,int,const xairo_uchar**);
	XAIRO_API_EXPORT CXairoISolution* thinCorpusTextFilter(const CXairoICorpusTextFilter*);
	XAIRO_API_EXPORT CXairoISolution* thinAddkeyFilter(const CXairoIAddkeyFilter*);
	XAIRO_API_EXPORT CXairoICollocationTable* makeCollocationTable(const xairo_uchar*,const xairo_uchar*,CXairoCollocationTable::cmeth,CXairoCollocationTable::_cwin,int,double,double,int);
	XAIRO_API_EXPORT void getAnalysis(int,int*,int,int*,int*);
	XAIRO_API_EXPORT void getAnalysisScope(int,int*,int,int*,int*,const xairo_uchar*);
	XAIRO_API_EXPORT const xairo_uchar* serialize() {return getId();}
//	XAIRO_API_EXPORT static CXairoISolution* deserialize(const xairo_uchar*);
	XAIRO_API_EXPORT CXairoISolution* copy();
	void release();
	const xairo_uchar* getId();
private:
	bool m_bOwns;
	CDBKey* m_key;
	CXairoServer* m_server;
	CXairoCollocationTable* makeCT(_clim,const xairo_uchar*,const xairo_uchar*,CXairoCollocationTable::cmeth);
	void addCT(int,int);
	void initCT();
	int m_ncolltab;
	_colt* m_colltab;
	int m_ctsize;
	static int qc(const void* v1,const void* v2);
	double cscore(CXairoCollocationTable::cmeth,int,int,int,int,int);
	const CXairoGrammar::Partition *m_part;
	int MeasureScope(xara_loc *,CStream*,CStream*);

};

#define CTALLOC 5000

XAIRO_NAMESPACE_END
