#pragma once

#include "../XairoHeader.h"

XAIRO_NAMESPACE_BEGIN



class CXairoError : public CXairoIError
{
public:
	CXairoError(CXairoIError::code c,const xairo_uchar* m):m_code(c),m_msg(_wcsdup(m)), m_sev(CXairoIError::SEV_ERROR) {}
	CXairoError(CXairoIError::code c,const xairo_uchar* m,CXairoIError::sev s):m_code(c),m_msg(_wcsdup(m)), m_sev(s) {}
	~CXairoError(void);
	XAIRO_API_EXPORT const xairo_uchar* getMessage() {return m_msg;}
	XAIRO_API_EXPORT CXairoIError::code getCode() {return m_code;}
	XAIRO_API_EXPORT CXairoIError::sev getSeverity() {return m_sev;}
	const xairo_uchar* m_msg;
	CXairoIError::code m_code;
	CXairoIError::sev m_sev;
};

XAIRO_NAMESPACE_END
