#pragma once

#define XAIRO_SERVER_API

#include "../XairoHeader.h"

XAIRO_NAMESPACE_BEGIN

enum rm {RM_GETWORDLIST,RM_GETFREQUENCYLIST,RM_GETFILTEREDFREQUENCYLIST,RM_WORDLIST_GETCOUNT,RM_WORDLIST_GETWORD,
	RM_WORD_GETFREQUENCY,RM_WORD_GETFILTEREDFREQUENCY,RM_WORD_GETFORMCOUNT,RM_WORD_GETNORM,RM_WORD_GETFORM,
	RM_FORM_GETFREQUENCY,RM_FORM_GETFILTEREDFREQUENCY,RM_FORM_GETADDITIONALKEY,RM_FORM_GETNORM,RM_FORM_GETTEXT,RM_FORM_INCLUDED,
	RM_EXTENDEDFORM_GETADDITIONALKEY,RM_EXTENDEDFORM_GETNORM,RM_EXTENDEDFORM_GETTEXT,RM_EXTENDEDFORM_GETTYPE,
	RM_GRAMMAR_GETADDKEYCOUNT,RM_GRAMMAR_GETADDKEY,
	RM_GRAMMAR_GETNAMESPACECOUNT,RM_GRAMMAR_GETNAMESPACE,
	RM_GRAMMAR_GETELEMENTCOUNT,RM_GRAMMAR_GETELEMENT,
	RM_GRAMMAR_GETGLOBALATTRIBUTECOUNT,RM_GRAMMAR_GETGLOBALATTRIBUTE,
	RM_GRAMMAR_GETATTRIBUTECOUNT,RM_GRAMMAR_GETATTRIBUTE,
	RM_GRAMMAR_GETLABELCOUNT,RM_GRAMMAR_GETLABEL,
	RM_GRAMMAR_GETWTAGCOUNT,RM_GRAMMAR_GETWTAG,
	RM_SOLVE,RM_SOLUTION_GETCOUNT,RM_SOLUTION_GETCORPUSTEXTCOUNT,
	RM_SOLUTION_GETHIT,RM_HIT_GETCORPUSTEXT,RM_HIT_GETTEXT,RM_CORPUSTEXT_GETTITLE,RM_CORPUSTEXT_CLASSIFY,
	RM_SOLUTION_THININIT,RM_SOLUTION_THINRAND,RM_SOLUTION_THINONEPERTEXT,
	RM_SOLUTION_THINCOLLOCATION,RM_SOLUTION_THINSELECTION,
	RM_SOLUTION_THINCORPUSTEXTFILTER,RM_SOLUTION_THINADDKEYFILTER,
	RM_SOLUTION_GETCOLLOCATIONTABLE,RM_SOLUTION_GETANALYSIS,RM_SOLUTION_GETANALYSISSCOPE,RM_SOLUTION_RELEASE,
	RM_COLLOCATIONTABLE_GETCOUNT,RM_COLLOCATIONTABLE_GETCOLLOCATE,
	RM_GETWORDCOUNT,RM_GETCORPUSNAME,RM_CORPUSTEXTLIST_GETCOUNT,RM_CORPUSTEXTLIST_GETCORPUSTEXT,
	RM_GETATTRIBUTEVALUELIST,RM_ATTRIBUTEVALUELIST_GETCOUNT,RM_ATTRIBUTEVALUELIST_GETATTRIBUTEVALUE,
	RM_ATTRIBUTEVALUE_GETFILTEREDFREQUENCY,
	RM_GRAMMAR_GETROOTPARTITION,RM_GRAMMAR_PARTITION_GETDIVISION,RM_GRAMMAR_PARTITION_GETWORDCOUNT,RM_GRAMMAR_PARTITION_GETINDEX,
	RM_CORPUSTEXT_EVALXPATH,RM_CORPUSTEXT_GETWORDCOUNT,RM_CORPUSTEXT_ISSELECTED,RM_CORPUSTEXT_GETTEXTENTITY,RM_CORPUSTEXT_GETINDEX,
	RM_GRAMMAR_CODEBOOK_LOOKUP,RM_GRAMMAR_CODEBOOK_GETCOUNT,RM_GRAMMAR_CODEBOOK_GETPAIR,
	RM_GRAMMAR_GETCODEPAGECOUNT,RM_GRAMMAR_GETCODEPAGE,RM_GRAMMAR_GETCHARACTERENTITYCOUNT,RM_GRAMMAR_GETCHARACTERENTITY,
	RM_GRAMMAR_GETDSC,RM_GETDEFAULTLANGUAGE,
	RM_CORPUSTEXTLIST_GETCORPUSTEXTFILTER,
	RM_GRAMMAR_GETLEMMASCHEME,RM_GRAMMAR_GETLEMMASCHEMECOUNT,
	RM_GRAMMAR_LEMMASCHEME_GETFACET,
	RM_GRAMMAR_GETREGION,RM_GRAMMAR_GETREGIONCOUNT,
	RM_GRAMMAR_REGION_GETVALUE,
	RM_SOLUTION_COPY,RM_GETADDKEYFILTER,
	RM_GETADDKEYVALUELIST,RM_ADDKEYVALUELIST_GETCOUNT,RM_ADDKEYVALUELIST_GETADDKEYVALUE,
	RM_MAX};



using namespace XERCES_CPP_NAMESPACE;

class CXairoStubServer:public CXairoIStubServer
{
public:
	CXairoStubServer(CXairoServer*);
	~CXairoStubServer(void);
	XAIRO_API_EXPORT char* Transport(const char*);
	XAIRO_API_EXPORT static CXairoStubServer* getServer();
	XAIRO_API_EXPORT static CXairoStubServer* getServer(CXairoInterface*);

private:
	CXairoServer* m_server;
	const xairo_uchar* RPCStub(DOMElement*);
	enum rm LUM(const xairo_uchar*);
	XercesDOMParser m_parser;
	XMLTranscoder* m_utf8;
	const char* Encode(const xairo_uchar*);

};

XAIRO_NAMESPACE_END
