#include "SServer.h"
#include "XairoWord.h"
#include "Dictionary.h"
#include "WordList.h"
#include "XairoCorpusTextFilter.h"
#include "XairoAddkeyFilter.h"

XAIRO_NAMESPACE_BEGIN

CXairoWord::~CXairoWord(void)
{
}

xara_lemma* CXairoWord::GetLemma()
{
	CDictionary* d=m_server->GetDict(m_d);
	return d->LookupEntry(m_p);
}

CXairoForm* CXairoWord::getForm(int i)
{
	return new CXairoForm(m_d,m_p,i,m_server);
}

/* withdrawn release 1.16
int CXairoWord::getFrequencyInSubcorpus(int np,int* p)
{
	int k=0;
	for (int i=0;i<getFormCount();i++) {
		CXairoForm* f=getForm(i);
		if (f==NULL) continue;
		k+=f->getFrequencyInSubcorpus(np,p);
	}
	return k;
}
*/

const xairo_uchar* CXairoWord::getNorm(int n)
{
	return m_server->GetWL()->GetWordW(GetLemma()->word[n]);
}

#define FW L("w(%d,%d)")


const xairo_uchar* CXairoWord::getId()
{
	return CXairoServer::MakeId(FW,m_d,m_p);
}

CXairoWord::CXairoWord(const xairo_uchar* id,CXairoServer* s):m_server(s)
{
	CXairoServer::ScanId(FW,id,&m_d,&m_p);
}

int CXairoWord::getFilteredFrequency(const CXairoICorpusTextFilter* fil,const CXairoIAddkeyFilter* ff)
{
	int k=0;
	CXairoAddkeyFilter* af=(CXairoAddkeyFilter*) ff;
	for (int i=0;i<getFormCount();i++) {
		CXairoForm* f=getForm(i);
		if (f==NULL) continue;
		if (af && !f->included(af)) continue; 		
		k+=fil?f->getFilteredFrequency(fil):f->getFrequency();
	}
	return k;
}

int CXairoWord::getFilteredFrequencyMap(int np,int* p,const CXairoIAddkeyFilter* ff)
{
	int k=0;
	CXairoAddkeyFilter* af=(CXairoAddkeyFilter*) ff;
	for (int i=0;i<getFormCount();i++) {
		CXairoForm* f=getForm(i);
		if (f==NULL) continue;
		if (af && !f->included(af)) continue; 		
		k+=p?f->getFilteredFrequencyMap(np,p):f->getFrequency();
	}
	return k;
}




XAIRO_NAMESPACE_END
