#include "SServer.h"
#include "language.h"


XAIRO_NAMESPACE_BEGIN

#define NORM_MODE UNORM_NFKC

CLanguage::CLanguage(CXairoServer* s):m_wbrules(NULL),m_wblocale("#def"),m_server(s)
{
}

CLanguage::~CLanguage(void)
{
}

UnicodeString CLanguage::MkLC(UnicodeString c)
{
	return c.foldCase();
}

UnicodeString CLanguage::MkNorm(UnicodeString c)
{
	UnicodeString cc;
	UErrorCode err=U_ZERO_ERROR;
	Normalizer::normalize(c,NORM_MODE,0,cc,err);
	assert (U_SUCCESS(err));
	return cc;
}

int CLanguage::Tokenise(UnicodeString in, UnicodeString*& out)
{
	m_brit->setText(in);
	int nn=0;
	int i=m_brit->first(); int i0=0; 
	do {
		bool b=true;
		for (int j=i0;j<i;j++) {
			if (!u_isUWhiteSpace(in[j])) b=false;
		}
		if (!b) {
			nn++;
		}
		i0=i;
		i=m_brit->next();
	}
	while (i!=BreakIterator::DONE);
	out=new UnicodeString [nn];
	i=m_brit->first(); i0=0; int k=0;
	do {
		bool b=true;
		for (int j=i0;j<i;j++) {
			if (!u_isUWhiteSpace(in[j])) b=false;
		}
		if (!b) {
			out[k++]=UnicodeString(in,i0,i-i0);
		}
		i0=i;
		i=m_brit->next();
	}
	while (i!=BreakIterator::DONE);
	return nn;
}

bool CLanguage::Load(const char* loc)
{
	m_wblocale=loc;
	UErrorCode e=U_ZERO_ERROR;
	m_brit=NULL;
	if (m_wbrules) {
		UParseError p;
		m_brit=new RuleBasedBreakIterator ((const UChar*) m_wbrules,p,e);
		if (e != U_ZERO_ERROR) {
			m_brit=NULL;
		}
	}
	e=U_ZERO_ERROR;
	const char* lx=NULL;
	if (strcmp(m_wblocale,"#def") != 0) lx=m_wblocale;
	Locale ll(lx);
	if (m_brit==NULL) m_brit=BreakIterator::createWordInstance(ll,e);
	assert(U_SUCCESS(e));
	m_collator = Collator::createInstance(ll,e);
	m_collator->setStrength(Collator::PRIMARY);
	assert(U_SUCCESS(e));
	if (!U_SUCCESS(e)) {
		m_server->BootLog(L("Failed to initialise locale %S (ICU err=%d)\n"),m_wblocale,e);
		return false;
	}
	return true;
}

XAIRO_NAMESPACE_END
