#pragma once

#include "../XairoHeader.h"

using namespace XAIRO_NAMESPACE;

#include "XairoProxyGrammar.h"

//#include <xercesc/dom/DOM.hpp>
//#include <xercesc/parsers/XercesDOMParser.hpp>

//using namespace XERCES_CPP_NAMESPACE;



//enum xmlrpc_type {XMLRPC_STRING,XMLRPC_I4,XMLRPC_BOOL,XMLRPC_DOUBLE,XMLRPC_VECTOR,XMLRPC_VECTORS};
/*
struct xmlrpc_arg {
	xmlrpc_type t;
	const xairo_uchar* s;
	int i;
	double d;
	int nvec;
	int* vec;
	const xairo_uchar** vecs;
};
*/

#include "RPCUtils.h"

using namespace PROXY_UTILS;


class CXairoSocketDefault : public CXairoTransport
{
public:
	CXairoSocketDefault(const char*,unsigned);
	void Start();
	void End();
	char* DoTransport(const char*);
	void Interrupt() {}
private:
	char* Transport(const char*);
	int Receive(char*&);
	PSOCKET m_socket;
	const char* m_address;
	unsigned m_port;
};

class CXairoLocalDefault : public CXairoTransport
{
public:
	CXairoLocalDefault(class CXairoIStubServer*);
	void Start();
	void End();
	char* DoTransport(const char*);
	void Interrupt() {}
private:
	class CXairoIStubServer* m_server;
};

class CXairoProxyServer : public CXairoInterface
{
public:
	CXairoProxyServer();
	CXairoProxyServer(CXairoInterface*);
	virtual ~CXairoProxyServer(void);
	class CXairoIWordList* getWordList(int,const xairo_uchar**,const xairo_uchar*);
//	DOMElement* RPCRemote(CString);
//	int RPCInt(DOMElement*,CString);
//	CString RPCString(DOMElement*,CString);
//	bool Init(const char*,CXairoBootMonitor*) {return false;}
	class CXairoIWordList* getFrequencyList(int,const xairo_uchar**,int,int,int,const xairo_uchar*);
	class CXairoIWordList* getFilteredFrequencyList(int,const xairo_uchar**,int,int,int,const xairo_uchar*,const CXairoICorpusTextFilter*,const CXairoIAddkeyFilter*);
	class CXairoIAttributeValueList* getAttributeValueList(const CXairoIGrammar::Attribute*);
	class CXairoIAddkeyValueList* getAddkeyValueList(const CXairoIGrammar::Addkey*);
	class CXairoISolution* solve(const xairo_uchar*);
//	class CXairoISolution* solveInDivision(const xairo_uchar*,CXairoIGrammar::Partition*);
	class CXairoICorpusTextList* getCorpusTextList();
	CXairoIGrammar* getGrammar() {return &m_grammar;}
	int getWordCount();
	void setInterruptHandler(CXairoIInterruptHandler*) {}
	const xairo_uchar* getCorpusName();
	const xairo_uchar* getDefaultLanguage();
	class CXairoIExtendedForm* getUsage(unsigned int);
	class CXairoIAddkeyFilter* getAddkeyFilter(const xairo_uchar* key,int nvals,const xairo_uchar** vals);

	void* deserialize(const xairo_uchar*);
/*
	DOMElement* RPCParam(DOMElement* e,int n);	
	DOMElement* RPCValue(DOMElement* e);
	DOMElement* RPCStruct(DOMElement* e);
	const xairo_uchar* RPCVal(xmlrpc_arg);
	const xairo_uchar* RPCName(DOMElement* e);
	const xairo_uchar* RPCString(DOMElement* e);
	const xairo_uchar* RPCStringParam(DOMElement* e,int);
	int RPCInt(DOMElement* e);
	double RPCDouble(DOMElement* e);
	int RPCIntParam(DOMElement*,int);
	int RPCVector(DOMElement* e,int*&);
	int RPCVectorParam(DOMElement*,int,int*&);
	double RPCDoubleParam(DOMElement*,int);
	bool RPCBool(DOMElement* e);
	bool RPCBoolParam(DOMElement*,int);
	const xairo_uchar* RPCParams(int n,const xmlrpc_arg* x);
	const xairo_uchar* RPCRet(int n,xmlrpc_arg* x);
	const xairo_uchar* RPCCall(const xairo_uchar*,int n,const xmlrpc_arg* x);
	const xairo_uchar* RPCEscape(const xairo_uchar*);
	const xairo_uchar* RPCUnescape(const xairo_uchar*);
*/
	bool Configure(bool,const char*,unsigned,XAIRO_NAMESPACE::CXairoIBootMonitor*);
	bool Configure(CXairoTransport*,XAIRO_NAMESPACE::CXairoIBootMonitor*);
	void Term();
	DOMElement* RPCRemote(const xairo_uchar* s);
	void Interrupt() {m_transport->Interrupt();}
private:
	CXairoTransport* m_transport;
	XercesDOMParser m_parser;
	const xairo_uchar* Transport(const xairo_uchar*);
	const xairo_uchar* RPCStub(DOMElement*);
//	enum rm LUM(const xairo_uchar*);
	class CXairoIStubServer* m_server;
	CXairoProxyGrammar m_grammar;
//	bool m_bLocal;
//	const char* m_address;
//	unsigned m_port;
	XMLTranscoder* m_utf8;
	static void Error(const xairo_uchar*);

};
