#pragma once
#include "XairoProxyServer.h"


class CXairoProxySolution :
	public CXairoISolution
{
public:
	CXairoProxySolution(const xairo_uchar*,CXairoProxyServer*);
	~CXairoProxySolution(void);
	int getCount();
	int getCorpusTextCount();
	CXairoIHit* getHit(int);
	CXairoISolution* thinInit(int n);
	CXairoISolution* thinRand(int n,int s);
	CXairoISolution* thinOnePerText();
	CXairoISolution* thinSelection(int n,int *s);
//	CXairoISolution* thinSubcorpus(int,int*);
	CXairoISolution* thinCollocation(const xairo_uchar*,CXairoICollocationTable::_cwin,int n,const xairo_uchar** s);
	CXairoISolution* thinCorpusTextFilter(const CXairoICorpusTextFilter*);
	CXairoISolution* thinAddkeyFilter(const CXairoIAddkeyFilter*);
	CXairoICollocationTable* makeCollocationTable(const xairo_uchar* pattern,const xairo_uchar* key,CXairoICollocationTable::cmeth m,CXairoICollocationTable::_cwin w,int maxn,double mins,double maxs,int lowf);
	void getAnalysis(int,int*,int n,int* a,int* b);
	void getAnalysisScope(int,int*,int n,int* a,int* b,const xairo_uchar*);
	const xairo_uchar* serialize();
	CXairoISolution* copy();

private:
	const xairo_uchar* m_id;
	CXairoProxyServer* m_server;
};
